<?php if (!defined('PmWiki')) exit();
/*  Copyright 2004 John Rankin  (john.rankin@affinity.co.nz)
    This file extends PmWiki; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    This script adds support for page drafts.
*/
$FmtWikiLinkPreDraft = $FmtWikiLink;
$FmtWikiLink = 'FmtWikiLinkDraft';
$WikiLibDirsPreDraft = $WikiLibDirs;

SDV($VisibleDrafts,true);
SDV($WikiDraftDir,'wiki.draft');
SDV($DraftText,' draft');
SDV($DeleteText,"delete&nbsp;draft");
SDV($DraftDeleteLinkFmt,"<a class='createlink' title='$DeleteText' " . 
    "href='\$PageUrl?action=deldraft'><sup>&minus;</sup></a>");
SDV($PageDraftDeleteFmt,"<small>$DraftText&nbsp;</small>$DraftDeleteLinkFmt");
SDV($DraftDeleteConfirmFmt," <a class='createlink' title='(no undo)' " . 
    "href='\$PageUrl?action=deletedraft'><small>$DeleteText</small></a>");
SDV($PageDraftExistsFmt,"\$LinkText<a class='createlink' " . 
    "title='Edit new page draft' href='\$PageUrl?action=edit'><sup>?*</sup></a>");
SDV($PageDraftExistsSpaceFmt, 
    str_replace('$LinkText','($LinkText)',$PageDraftExistsFmt));
SDV($PageDraftBrowseNewFmt," <a class='createlink' " . 
    "title='View new page draft' href='\$PageUrl?action=draft'>*</a>");
SDV($PageDraftBrowseFmt,str_replace('new ','',$PageDraftBrowseNewFmt));
if (PageExists($pagename)) $PageDraftDeleteFmt = " <a class='createlink' " . 
    "title='View original page' href='\$PageUrl'><sup>&laquo;</sup></a>" . 
    $PageDraftDeleteFmt;
$PageEditFmt = str_replace('[Preview]','[Preview & Save Draft]',$PageEditFmt);
SetDraftFmts($pagename,(@$_POST['editoriginal'] ? false : true));
if ($action=='edit') {
    if (@$_POST['editoriginal'] || $restore) {
        $DraftTagTitleFmt = '';
        $PageEditFmt = str_replace('Save Draft','Overwrite Newer Draft',
            $PageEditFmt);
    } elseif ($preview) {
        $EnableEditOriginal = PageDraftExists($pagename) ? false : true;
        MakeDraft($pagename);
        SetDraftFmts($pagename,$EnableEditOriginal);
    } elseif (@$_POST['post'])
        UnMakeDraft($pagename);
    else
        array_unshift($WikiLibDirs,&$WikiDraftDir);
    if (PageDraftExists($pagename))
        $DraftLinkFmt .= "&emsp;" . FmtPageName($DraftDeleteLinkFmt,$pagename);
} elseif ($action=='draft') {
    array_unshift($WikiLibDirs,&$WikiDraftDir);
    if (PageDraftExists($pagename))
        $DraftLinkFmt = FmtPageName($PageDraftDeleteFmt,$pagename);
    $action = 'browse';
} elseif ($action=='deldraft') {
    array_unshift($WikiLibDirs,&$WikiDraftDir);
    if (PageDraftExists($pagename))
        $DraftLinkFmt= FmtPageName($DraftDeleteConfirmFmt,$pagename);
    $HTMLTitleFmt = str_replace('$HTMLTitle','Delete $HTMLTitle',$HTMLTitleFmt);
    $action = 'browse';    
} elseif ($action=='deletedraft') {
    UnMakeDraft($pagename);
    Redirect($pagename);
} else $DraftTagTitleFmt = '';
$HTMLTitleFmt = 
    str_replace('$HTMLTitle','$HTMLTitle'.$DraftTagTitleFmt,$HTMLTitleFmt);
$PageEditFmt = str_replace('[Editing $PageName]','[Editing $PageName]' . 
    $DraftTagTitleFmt,$PageEditFmt);
SDV($PageExists,'PageExists');
    
function MakeDraft($pagename) {
  global $WikiDir,$WikiDraftDir,$PostFields;
  foreach($PostFields as $k) {
    if (isset($_POST[$k]))
      $new[$k]=str_replace("\r","",stripmagic($_POST[$k])); 
  }
  $page = RetrieveAuthPage($pagename,"read");
  if (!$page) { Abort("?cannot make draft of $pagename"); }
  if ($new['text']==$page['text']) return;
  foreach($new as $k=>$v) {
    if ($k=='pagename' || $k=='action') continue;
    $page[$k] = $v;
  }
  $oWikiDir = $WikiDir;
  $WikiDir = $WikiDraftDir;
  WritePage($pagename,$page);
  $WikiDir = $oWikiDir;
}

function UnMakeDraft($pagename) {
  global $WikiDraftDir,$PageFileFmt;
  $draftpagefile = FmtPageName("$WikiDraftDir/$PageFileFmt",$pagename);
  if (PageDraftExists($pagename)) unlink($draftpagefile);
}

function PageDraftExists($pagename) {
  global $WikiLibDirs,$WikiDraftDir;
  $oWikiLibDirs = $WikiLibDirs;
  $WikiLibDirs = array(&$WikiDraftDir);
  $r = (PageExists($pagename)) ? true : false;
  $WikiLibDirs = $oWikiLibDirs;
  return $r;
}

function SetDraftFmts($pagename,$EnableEditOriginal) {
  global $DraftTagFmt,$DraftLinkFmt,$PageDraftBrowseFmt,$PageDraftBrowseNewFmt,
         $DraftText,$PageEditFmt,$DraftTagTitleFmt,$PageDraftDeleteFmt;
  if (PageDraftExists($pagename)) {
      $DraftTagFmt = ucwords($DraftText);
      $DraftLinkFmt = (PageExists($pagename)) ? 
            FmtPageName($PageDraftBrowseFmt,$pagename) :
            FmtPageName($PageDraftBrowseNewFmt,$pagename);
      if ($EnableEditOriginal) $PageEditFmt = str_replace('$[Reset]','$[Reset]' . 
            " '/><input type='submit' name='editoriginal' value=' " . 
            '$[Edit Original' . (PageExists($pagename) ? '' : ' New') . ' Page]',
            $PageEditFmt);
  } else {
      $DraftTagFmt = '';
      $DraftLinkFmt= '';
  }
  $DraftTagTitleFmt = $DraftTagFmt;
}

function FmtWikiLinkDraft($pat,$ref,$btext,$out=NULL,$pname=NULL) {
  global $WikiPageCreateFmt,$WikiPageCreateSpaceFmt,$FmtWikiLinkPreDraft,
         $PageDraftExistsFmt,$PageDraftExistsSpaceFmt,$PageDraftBrowseFmt,
         $WikiLibDirsPreDraft,$WikiLibDirs,$VisibleDrafts,$PageExists;
  $WikiLibDirs = $WikiLibDirsPreDraft;
  $ha=$WikiPageCreateFmt;
  $hb=$WikiPageCreateSpaceFmt;
  $pg = FmtWikiLink($pat,$ref,$btext,'PageName',$pname);
  if (PageDraftExists($pg))
      if ($PageExists($pg)) {
          $r = $VisibleDrafts ? FmtPageName($PageDraftBrowseFmt,$pg) : '';
      } else {
          $WikiPageCreateFmt = $PageDraftExistsFmt;
          $WikiPageCreateSpaceFmt = $PageDraftExistsSpaceFmt;
      }
  $r = $FmtWikiLinkPreDraft($pat,$ref,$btext,$out,$pname) . $r;
  $WikiPageCreateFmt=$ha;
  $WikiPageCreateSpaceFmt=$hb;
  return $r;
}

?>
